<?php
/*
	*	Developed by sepordeh Team
	*	Copyright 2020 Sepordeh
	*	Sepordeh.com
*/
if (!defined("WHMCS")){
	exit("This file cannot be accessed directly");
}

function sepordeh_config()
{
    return array(
        "FriendlyName" => array(
            "Type" => "System",
            "Value" => 'Sepordeh'
        ),
        "merchant" => array(
            "FriendlyName" => "مرچنت کد",
            "Type" => 'text',
            "Size" => '255',
            "Value" => "",
        ),
        "currency" => array(
            "FriendlyName" => "واحد پولی",
            "Type" => 'dropdown',
            "Options" => "Rial,Toman",
        ),
    );
}

function sepordeh_link($params)
{
	if(isset($_POST["sepordeh_pay"])){
		$err = false;
		$amount = strtok($params['amount'], '.');
		$amount = ($params['currency']=='Rial') ? intval($amount/10):intval($amount);
		$callbackUrl = $params['systemurl'] . '/modules/gateways/callback/sepordeh.php?invoiceid=' . $params['invoiceid'] . '&amount=' . $params['amount'] . '&currency=' . $params['currency'];
			
		$url='https://sepordeh.com/merchant/invoices/add';
		$params=array(
			'merchant'          => $params['merchant'],
			'amount'       => $amount,
			'callback'     => $callbackUrl,
			'orderId' => $params['invoiceid'],
			'description'  => sprintf('پرداخت فاکتور #%s', $params['invoiceid']),
		);
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$res = curl_exec($ch);
		curl_close($ch);
		if (!$res)
			$err = 'اتصال به بانک برقرار نشد .';
		else{
			$result = json_decode($res);
			if ($result->status == 200) {
				$go = "https://sepordeh.com/merchant/invoices/pay/automatic:true/id:".$result->information->invoice_id;
				header("Location: $go");
			} else {
				$err = 'اتصال به درگاه امکان پذیر نیست: '. $result->message;
			}
		}
		return $err;
	}
	$htmlOutput = '<form method="POST" action="">';
    $htmlOutput .= '<input type="submit" name="sepordeh_pay" value="پرداخت" />';
    $htmlOutput .= '</form>';
    return $htmlOutput;
}