<?php
/*
	*	Developed by sepordeh Team
	*	Copyright 2020 Sepordeh
	*	Sepordeh.com
*/
if(file_exists('../../../init.php'))
{
    define('WHMCSDBCONNECT', true);
    require('../../../init.php');
}
else
    require('../../../dbconnect.php');

include('../../../includes/functions.php');
include('../../../includes/gatewayfunctions.php');
include('../../../includes/invoicefunctions.php');


$gatewaymoduleName = 'sepordeh';
$gateway = getGatewayVariables($gatewaymoduleName);
if(!$gateway['type']) die('Module Not Activated');


$amount = $_GET['amount'];
$invoiceid = (int) $_GET['invoiceid'];
$au = !empty($_POST["transid"]) ? $_POST["transid"] : 0;
$invoiceid = checkCbInvoiceID($invoiceid, $gateway["name"]);

if(isset($_GET['authority'])){
	$url='https://sepordeh.com/merchant/invoices/verify';
	$params= [
			'merchant' 	=> $gateway['merchant'],
			'authority' => $_GET['authority'],
		];
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	$res = curl_exec($ch);
	
	curl_close($ch);
	if(!$res)
	{
		echo '<meta charset=utf-8><center><font>ارتباط با مشکل روبرو شد</font><br/><a color="red" href="javascript:window.location.reload()">بررسی مجدد</a></center>';
		exit;
	}
	$result = json_decode($res);
	if ($result->status == 200) {
        addInvoicePayment($invoiceid, $result->information->invoice_id, $amount, 0, $gatewaymoduleName);
        logTransaction($gateway["name"], $_REQUEST, "Successful");
    }
    else
    {
        logTransaction($gateway["name"], $_REQUEST, "Unsuccessful");
    }
}

$url = $CONFIG['SystemURL'] . '/viewinvoice.php?id=' . $invoiceid;
header("Location: {$url}");
?>